/*avr header*/
#include <avr/io.h>
/*interrupt header*/
#include <avr/interrupt.h>
#include <util/delay.h>
#include<avr/pgmspace.h> 

/*Ͷ*/
#define uint8	 unsigned char
#define uint16	 unsigned short 
#define uint32	 unsigned long 

#define LED_DAT_DDR	DDRD
#define LED_DAT_PORT	PORTD

#define LS138_E_DDR		DDRB
#define LS138_E_PORT	PORTB
#define LS138_E_BIT		PB3
#define LS138_E_H		LS138_E_PORT |= (1<<LS138_E_BIT)
#define LS138_E_L		LS138_E_PORT &= ~(1<<LS138_E_BIT)

#define LS138_A_DDR		DDRB
#define LS138_A_PORT	PORTB
#define LS138_A_BIT		PB0
#define LS138_A_H		LS138_A_PORT |= (1<<LS138_A_BIT)
#define LS138_A_L		LS138_A_PORT &= ~(1<<LS138_A_BIT)

#define LS138_B_DDR		DDRB
#define LS138_B_PORT	PORTB
#define LS138_B_BIT		PB1
#define LS138_B_H		LS138_B_PORT |= (1<<LS138_B_BIT)
#define LS138_B_L		LS138_B_PORT &= ~(1<<LS138_B_BIT)

#define LS138_C_DDR		DDRB
#define LS138_C_PORT	PORTB
#define LS138_C_BIT		PB2
#define LS138_C_H		LS138_C_PORT |= (1<<LS138_C_BIT)
#define LS138_C_L		LS138_C_PORT &= ~(1<<LS138_C_BIT)

#define HC595_D0_DDR		DDRD
#define HC595_D0_PORT		PORTD
#define HC595_D0_BIT		PD4
#define HC595_D0_H		HC595_D0_PORT |= (1<<HC595_D0_BIT)
#define HC595_D0_L		HC595_D0_PORT &= ~(1<<HC595_D0_BIT)

#define HC595_D1_DDR		DDRD
#define HC595_D1_PORT		PORTD
#define HC595_D1_BIT		PD5
#define HC595_D1_H		HC595_D1_PORT |= (1<<HC595_D1_BIT)
#define HC595_D1_L		HC595_D1_PORT &= ~(1<<HC595_D1_BIT)

#define HC595_D2_DDR		DDRD
#define HC595_D2_PORT		PORTD
#define HC595_D2_BIT		PD6
#define HC595_D2_H		HC595_D2_PORT |= (1<<HC595_D2_BIT)
#define HC595_D2_L		HC595_D2_PORT &= ~(1<<HC595_D2_BIT)

#define HC595_D3_DDR		DDRD
#define HC595_D3_PORT		PORTD
#define HC595_D3_BIT		PD7
#define HC595_D3_H		HC595_D3_PORT |= (1<<HC595_D3_BIT)
#define HC595_D3_L		HC595_D3_PORT &= ~(1<<HC595_D3_BIT)

#define HC595_RCK_DDR		DDRD
#define HC595_RCK_PORT		PORTD
#define HC595_RCK_BIT		PD2
#define HC595_RCK_H		HC595_RCK_PORT |= (1<<HC595_RCK_BIT)
#define HC595_RCK_L		HC595_RCK_PORT &= ~(1<<HC595_RCK_BIT)

#define HC595_SRCK_DDR		DDRD
#define HC595_SRCK_PORT	PORTD
#define HC595_SRCK_BIT		PD3
#define HC595_SRCK_H		HC595_SRCK_PORT |= (1<<HC595_SRCK_BIT)
#define HC595_SRCK_L		HC595_SRCK_PORT &= ~(1<<HC595_SRCK_BIT)

#define LED_SCREEN_INI() 	{\
						LS138_E_DDR |= 1<<LS138_E_BIT;\
						LS138_A_DDR |= 1<<LS138_A_BIT;\
						LS138_B_DDR |= 1<<LS138_B_BIT;\
						LS138_C_DDR |= 1<<LS138_C_BIT;\
						HC595_D0_DDR |= 1<<HC595_D0_BIT;\
						HC595_D1_DDR |= 1<<HC595_D1_BIT;\
						HC595_D2_DDR |= 1<<HC595_D2_BIT;\
						HC595_D3_DDR |= 1<<HC595_D3_BIT;\
						HC595_RCK_DDR |= 1<<HC595_RCK_BIT;\
						HC595_SRCK_DDR |= 1<<HC595_SRCK_BIT;\
						LS138_E_L;\
						LS138_A_L;\
						LS138_B_L;\
						LS138_C_L;\
						HC595_D0_L;\
						HC595_D1_L;\
						HC595_D2_L;\
						HC595_D3_L;\
						HC595_RCK_L;\
						HC595_SRCK_L;\
						}


volatile uint8 display_cnt; /*ڶʱʾܵλ*/

volatile uint8 digital_display_buff[8] = {0,0,0,0,0,0,0,0};

/*******************ֿ***********************/
const uint8 CTAB[0x60][0x10] PROGMEM =
{
/*--  :     --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

/*--  :  !  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x30,0x00,0x00,0x00,

/*--  :  "  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x10,0x0C,0x06,0x10,0x0C,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

/*--  :  #  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x40,0xC0,0x78,0x40,0xC0,0x78,0x40,0x00,0x04,0x3F,0x04,0x04,0x3F,0x04,0x04,0x00,

/*--  :  $  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x70,0x88,0xFC,0x08,0x30,0x00,0x00,0x00,0x18,0x20,0xFF,0x21,0x1E,0x00,0x00,

/*--  :  %  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xF0,0x08,0xF0,0x00,0xE0,0x18,0x00,0x00,0x00,0x21,0x1C,0x03,0x1E,0x21,0x1E,0x00,

/*--  :  &  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0xF0,0x08,0x88,0x70,0x00,0x00,0x00,0x1E,0x21,0x23,0x24,0x19,0x27,0x21,0x10,

/*--  :  '  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x10,0x16,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

/*--  :  (  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0xE0,0x18,0x04,0x02,0x00,0x00,0x00,0x00,0x07,0x18,0x20,0x40,0x00,

/*--  :  )  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x02,0x04,0x18,0xE0,0x00,0x00,0x00,0x00,0x40,0x20,0x18,0x07,0x00,0x00,0x00,

/*--  :  *  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x40,0x40,0x80,0xF0,0x80,0x40,0x40,0x00,0x02,0x02,0x01,0x0F,0x01,0x02,0x02,0x00,

/*--  :  +  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x1F,0x01,0x01,0x01,0x00,

/*--  :  ,  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xB0,0x70,0x00,0x00,0x00,0x00,0x00,

/*--  :  -  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,

/*--  :  .  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x00,

/*--  :  /  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x80,0x60,0x18,0x04,0x00,0x60,0x18,0x06,0x01,0x00,0x00,0x00,

/*--  :  0  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0xE0,0x10,0x08,0x08,0x10,0xE0,0x00,0x00,0x0F,0x10,0x20,0x20,0x10,0x0F,0x00,

/*--  :  1  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x10,0x10,0xF8,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,

/*--  :  2  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x70,0x08,0x08,0x08,0x88,0x70,0x00,0x00,0x30,0x28,0x24,0x22,0x21,0x30,0x00,

/*--  :  3  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x30,0x08,0x88,0x88,0x48,0x30,0x00,0x00,0x18,0x20,0x20,0x20,0x11,0x0E,0x00,

/*--  :  4  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0xC0,0x20,0x10,0xF8,0x00,0x00,0x00,0x07,0x04,0x24,0x24,0x3F,0x24,0x00,

/*--  :  5  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0xF8,0x08,0x88,0x88,0x08,0x08,0x00,0x00,0x19,0x21,0x20,0x20,0x11,0x0E,0x00,

/*--  :  6  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0xE0,0x10,0x88,0x88,0x18,0x00,0x00,0x00,0x0F,0x11,0x20,0x20,0x11,0x0E,0x00,

/*--  :  7  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x38,0x08,0x08,0xC8,0x38,0x08,0x00,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x00,

/*--  :  8  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x70,0x88,0x08,0x08,0x88,0x70,0x00,0x00,0x1C,0x22,0x21,0x21,0x22,0x1C,0x00,

/*--  :  9  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0xE0,0x10,0x08,0x08,0x10,0xE0,0x00,0x00,0x00,0x31,0x22,0x22,0x11,0x0F,0x00,

/*--  :  :  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,

/*--  :  ;  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x60,0x00,0x00,0x00,0x00,

/*--  :  <  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x80,0x40,0x20,0x10,0x08,0x00,0x00,0x01,0x02,0x04,0x08,0x10,0x20,0x00,

/*--  :  =  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x00,

/*--  :  >  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x08,0x10,0x20,0x40,0x80,0x00,0x00,0x00,0x20,0x10,0x08,0x04,0x02,0x01,0x00,

/*--  :  ?  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x70,0x48,0x08,0x08,0x08,0xF0,0x00,0x00,0x00,0x00,0x30,0x36,0x01,0x00,0x00,

/*--  :  @  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xC0,0x30,0xC8,0x28,0xE8,0x10,0xE0,0x00,0x07,0x18,0x27,0x24,0x23,0x14,0x0B,0x00,

/*--  :  A  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0xC0,0x38,0xE0,0x00,0x00,0x00,0x20,0x3C,0x23,0x02,0x02,0x27,0x38,0x20,

/*--  :  B  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x88,0x88,0x88,0x70,0x00,0x00,0x20,0x3F,0x20,0x20,0x20,0x11,0x0E,0x00,

/*--  :  C  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xC0,0x30,0x08,0x08,0x08,0x08,0x38,0x00,0x07,0x18,0x20,0x20,0x20,0x10,0x08,0x00,

/*--  :  D  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x08,0x08,0x08,0x10,0xE0,0x00,0x20,0x3F,0x20,0x20,0x20,0x10,0x0F,0x00,

/*--  :  E  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x88,0x88,0xE8,0x08,0x10,0x00,0x20,0x3F,0x20,0x20,0x23,0x20,0x18,0x00,

/*--  :  F  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x88,0x88,0xE8,0x08,0x10,0x00,0x20,0x3F,0x20,0x00,0x03,0x00,0x00,0x00,

/*--  :  G  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xC0,0x30,0x08,0x08,0x08,0x38,0x00,0x00,0x07,0x18,0x20,0x20,0x22,0x1E,0x02,0x00,

/*--  :  H  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x08,0x00,0x00,0x08,0xF8,0x08,0x20,0x3F,0x21,0x01,0x01,0x21,0x3F,0x20,

/*--  :  I  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x08,0x08,0xF8,0x08,0x08,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,

/*--  :  J  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x08,0x08,0xF8,0x08,0x08,0x00,0xC0,0x80,0x80,0x80,0x7F,0x00,0x00,0x00,

/*--  :  K  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x88,0xC0,0x28,0x18,0x08,0x00,0x20,0x3F,0x20,0x01,0x26,0x38,0x20,0x00,

/*--  :  L  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x08,0x00,0x00,0x00,0x00,0x00,0x20,0x3F,0x20,0x20,0x20,0x20,0x30,0x00,

/*--  :  M  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0xF8,0x00,0xF8,0xF8,0x08,0x00,0x20,0x3F,0x00,0x3F,0x00,0x3F,0x20,0x00,

/*--  :  N  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x30,0xC0,0x00,0x08,0xF8,0x08,0x20,0x3F,0x20,0x00,0x07,0x18,0x3F,0x00,

/*--  :  O  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xE0,0x10,0x08,0x08,0x08,0x10,0xE0,0x00,0x0F,0x10,0x20,0x20,0x20,0x10,0x0F,0x00,

/*--  :  P  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x08,0x08,0x08,0x08,0xF0,0x00,0x20,0x3F,0x21,0x01,0x01,0x01,0x00,0x00,

/*--  :  Q  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xE0,0x10,0x08,0x08,0x08,0x10,0xE0,0x00,0x0F,0x18,0x24,0x24,0x38,0x50,0x4F,0x00,

/*--  :  R  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x88,0x88,0x88,0x88,0x70,0x00,0x20,0x3F,0x20,0x00,0x03,0x0C,0x30,0x20,

/*--  :  S  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x70,0x88,0x08,0x08,0x08,0x38,0x00,0x00,0x38,0x20,0x21,0x21,0x22,0x1C,0x00,

/*--  :  T  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x18,0x08,0x08,0xF8,0x08,0x08,0x18,0x00,0x00,0x00,0x20,0x3F,0x20,0x00,0x00,0x00,

/*--  :  U  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x08,0x00,0x00,0x08,0xF8,0x08,0x00,0x1F,0x20,0x20,0x20,0x20,0x1F,0x00,

/*--  :  V  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0x78,0x88,0x00,0x00,0xC8,0x38,0x08,0x00,0x00,0x07,0x38,0x0E,0x01,0x00,0x00,

/*--  :  W  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0xF8,0x08,0x00,0xF8,0x00,0x08,0xF8,0x00,0x03,0x3C,0x07,0x00,0x07,0x3C,0x03,0x00,

/*--  :  X  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0x18,0x68,0x80,0x80,0x68,0x18,0x08,0x20,0x30,0x2C,0x03,0x03,0x2C,0x30,0x20,

/*--  :  Y  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0x38,0xC8,0x00,0xC8,0x38,0x08,0x00,0x00,0x00,0x20,0x3F,0x20,0x00,0x00,0x00,

/*--  :  Z  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x10,0x08,0x08,0x08,0xC8,0x38,0x08,0x00,0x20,0x38,0x26,0x21,0x20,0x20,0x18,0x00,

/*--  :  [  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0xFE,0x02,0x02,0x02,0x00,0x00,0x00,0x00,0x7F,0x40,0x40,0x40,0x00,

/*--  :  \  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x0C,0x30,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x06,0x38,0xC0,0x00,

/*--  :  ]  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x02,0x02,0x02,0xFE,0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x7F,0x00,0x00,0x00,

/*--  :  ^  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x04,0x02,0x02,0x02,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

/*--  :  _  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,

/*--  :  `  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x02,0x02,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

/*--  :  a  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x19,0x24,0x22,0x22,0x22,0x3F,0x20,

/*--  :  b  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x3F,0x11,0x20,0x20,0x11,0x0E,0x00,

/*--  :  c  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0x00,0x0E,0x11,0x20,0x20,0x20,0x11,0x00,

/*--  :  d  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x80,0x80,0x88,0xF8,0x00,0x00,0x0E,0x11,0x20,0x20,0x10,0x3F,0x20,

/*--  :  e  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x1F,0x22,0x22,0x22,0x22,0x13,0x00,

/*--  :  f  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x80,0x80,0xF0,0x88,0x88,0x88,0x18,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,

/*--  :  g  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x6B,0x94,0x94,0x94,0x93,0x60,0x00,

/*--  :  h  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x00,0x80,0x80,0x80,0x00,0x00,0x20,0x3F,0x21,0x00,0x00,0x20,0x3F,0x20,

/*--  :  i  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x80,0x98,0x98,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,

/*--  :  j  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x80,0x98,0x98,0x00,0x00,0x00,0xC0,0x80,0x80,0x80,0x7F,0x00,0x00,

/*--  :  k  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x08,0xF8,0x00,0x00,0x80,0x80,0x80,0x00,0x20,0x3F,0x24,0x02,0x2D,0x30,0x20,0x00,

/*--  :  l  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x08,0x08,0xF8,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,

/*--  :  m  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x20,0x3F,0x20,0x00,0x3F,0x20,0x00,0x3F,

/*--  :  n  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x00,0x80,0x80,0x80,0x00,0x00,0x20,0x3F,0x21,0x00,0x00,0x20,0x3F,0x20,

/*--  :  o  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x1F,0x20,0x20,0x20,0x20,0x1F,0x00,

/*--  :  p  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x00,0x80,0x80,0x00,0x00,0x00,0x80,0xFF,0xA1,0x20,0x20,0x11,0x0E,0x00,

/*--  :  q  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x0E,0x11,0x20,0x20,0xA0,0xFF,0x80,

/*--  :  r  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x80,0x00,0x80,0x80,0x80,0x00,0x20,0x20,0x3F,0x21,0x20,0x00,0x01,0x00,

/*--  :  s  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x33,0x24,0x24,0x24,0x24,0x19,0x00,

/*--  :  t  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x80,0x80,0xE0,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x1F,0x20,0x20,0x00,0x00,

/*--  :  u  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x1F,0x20,0x20,0x20,0x10,0x3F,0x20,

/*--  :  v  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x80,0x00,0x00,0x80,0x80,0x80,0x00,0x01,0x0E,0x30,0x08,0x06,0x01,0x00,

/*--  :  w  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x00,0x80,0x00,0x80,0x80,0x80,0x0F,0x30,0x0C,0x03,0x0C,0x30,0x0F,0x00,

/*--  :  x  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x80,0x80,0x00,0x80,0x80,0x80,0x00,0x00,0x20,0x31,0x2E,0x0E,0x31,0x20,0x00,

/*--  :  y  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x80,0x80,0x80,0x00,0x00,0x80,0x80,0x80,0x80,0x81,0x8E,0x70,0x18,0x06,0x01,0x00,

/*--  :  z  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x21,0x30,0x2C,0x22,0x21,0x30,0x00,

/*--  :  {  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0x80,0x7C,0x02,0x02,0x00,0x00,0x00,0x00,0x00,0x3F,0x40,0x40,

/*--  :  |  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,

/*--  :  }  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x02,0x02,0x7C,0x80,0x00,0x00,0x00,0x00,0x40,0x40,0x3F,0x00,0x00,0x00,0x00,

/*--  :  ~  --*/
/*--  12;  ¶ӦĵΪx=8x16   --*/
0x00,0x06,0x01,0x01,0x02,0x02,0x04,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,


};

const uint8 test[][0x20] PROGMEM =
{
/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x01,0x00,0x01,0x00,0x01,0xF8,0x01,0x00,0x01,0x10,0x1F,0xF8,0x10,0x10,0x10,0x10,
0x10,0x10,0x1F,0xF0,0x10,0x10,0x01,0x10,0x28,0x88,0x24,0x44,0x44,0x44,0x00,0x00,

/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x00,0x80,0xF8,0x80,0x88,0x80,0x97,0xFC,0xA1,0x00,0x91,0x40,0x8A,0x40,0x8F,0xFC,
0x88,0x40,0xA8,0x40,0x97,0xFE,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,

/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x3F,0xFC,0x20,0x04,0x20,0x04,0x3F,0xFC,0x24,0x10,0x22,0x20,0x2F,0xFC,0x22,0x20,
0x22,0x20,0x3F,0xFE,0x22,0x20,0x22,0x20,0x44,0x20,0x44,0x20,0x88,0x20,0x10,0x20,

/*--  :  Ļ  --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x04,0x40,0xFF,0xFE,0x04,0x40,0x1F,0xF0,0x10,0x10,0x1F,0xF0,0x10,0x10,0x1F,0xF0,
0x02,0x00,0xFF,0xFE,0x09,0x10,0x1F,0xE8,0x29,0x26,0xC9,0x24,0x09,0x60,0x01,0x00,

/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x01,0x00,0x3F,0xFC,0x08,0x20,0x04,0x40,0xFF,0xFE,0x00,0x00,0x1F,0xF0,0x10,0x10,
0x1F,0xF0,0x10,0x10,0x1F,0xF0,0x01,0x00,0xFF,0xFE,0x01,0x00,0x01,0x00,0x01,0x00,

/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x08,0x20,0x08,0x20,0x7F,0xFC,0x08,0x20,0x08,0x20,0x0F,0xE0,0x08,0x20,0x0F,0xE0,
0x08,0x20,0x08,0x20,0xFF,0xFE,0x08,0x40,0x0C,0x20,0x18,0x10,0x30,0x18,0x40,0x10,

/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x20,0x40,0x10,0x40,0x10,0x40,0x07,0xFE,0x84,0x44,0x54,0x40,0x54,0x40,0x17,0xF8,
0x25,0x08,0x24,0x90,0xE4,0x90,0x24,0x60,0x28,0x60,0x28,0x98,0x31,0x0E,0x26,0x04,

/*--  :    --*/
/*--  12;  ¶ӦĵΪx=16x16   --*/
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x30,0x00,0x48,0x00,0x48,0x00,0x30,0x00,0x00,0x00,0x00,0x00
};



uint8 display_buffer[256];

void writeOneHanzi(uint8 x, uint8 y,uint8 index)
{
	uint8 temp;
	uint8 i;
	for(i=0;i<16;i++)
	{
		temp = pgm_read_byte(&test[index][i*2]);
		display_buffer[(y+i)*8+x] = temp;
		temp = pgm_read_byte(&test[index][i*2+1]);
		display_buffer[(y+i)*8+x+1] = temp;
	}
	
}

void writeTest()
{
	writeOneHanzi(0,0,0);
	writeOneHanzi(2,0,1);
	writeOneHanzi(4,0,2);
	writeOneHanzi(6,0,3);
	writeOneHanzi(0,16,4);
	writeOneHanzi(2,16,5);
	writeOneHanzi(4,16,6);
	writeOneHanzi(6,16,7);
}

void delay(uint16 ms)
{
	while(ms--)_delay_ms(1);
}


/*ʱ0ʼʾ밴Ĵ*/
void Timer0_Initial()
{
	display_cnt = 0;	/**/
	//TCNT0=0x00;			/*ʱֵ,ûʵ*/
	//TCCR0A=0x00;
	//TCCR0B=0x03;		/*ͨģʽ64Ƶ*/
	TCCR0 = 0x03;
	TIMSK |= 1<<TOIE0;
	//TIMSK0 |= 1<<TOIE0;	/*ж*/
 	sei();				/*ж*/
}


/*ʱ0жϷʾ밴Ĵ*/
SIGNAL(TIMER0_OVF_vect)
{
	uint8 i;
	signed char j;
	uint8 *ptr0,*ptr1,*ptr2,*ptr3;
	
	switch(display_cnt)
	{
		case 0:	ptr0 = &display_buffer[0];
				ptr1 = &display_buffer[64];
				ptr2 = &display_buffer[128];
				ptr3 = &display_buffer[192];
				break;
		case 1:	ptr0 = &display_buffer[0+1*8];
				ptr1 = &display_buffer[64+1*8];
				ptr2 = &display_buffer[128+1*8];
				ptr3 = &display_buffer[192+1*8];
				break;
		case 2:	ptr0 = &display_buffer[0+2*8];
				ptr1 = &display_buffer[64+2*8];
				ptr2 = &display_buffer[128+2*8];
				ptr3 = &display_buffer[192+2*8];
				break;
		case 3:	ptr0 = &display_buffer[0+3*8];
				ptr1 = &display_buffer[64+3*8];
				ptr2 = &display_buffer[128+3*8];
				ptr3 = &display_buffer[192+3*8];
				break;
		case 4:	ptr0 = &display_buffer[0+4*8];
				ptr1 = &display_buffer[64+4*8];
				ptr2 = &display_buffer[128+4*8];
				ptr3 = &display_buffer[192+4*8];
				break;
		case 5:	ptr0 = &display_buffer[0+5*8];
				ptr1 = &display_buffer[64+5*8];
				ptr2 = &display_buffer[128+5*8];
				ptr3 = &display_buffer[192+5*8];
				break;
		case 6:	ptr0 = &display_buffer[0+6*8];
				ptr1 = &display_buffer[64+6*8];
				ptr2 = &display_buffer[128+6*8];
				ptr3 = &display_buffer[192+6*8];
				break;
		case 7:	ptr0 = &display_buffer[0+7*8];
				ptr1 = &display_buffer[64+7*8];
				ptr2 = &display_buffer[128+7*8];
				ptr3 = &display_buffer[192+7*8];
				break;

	}
	for(i=0;i<8;i++)
	{
		for(j=7;j>=0;j--)
		{
			HC595_D0_H;
			HC595_D1_H;
			HC595_D2_H;
			HC595_D3_H;

			if(*ptr0 & 1<<j)
				HC595_D0_L;
			if(*ptr1 & 1<<j)
				HC595_D1_L;
			if(*ptr2 & 1<<j)
				HC595_D2_L;
			if(*ptr3 & 1<<j)
				HC595_D3_L;
	
			HC595_SRCK_L;
			//_delay_us(1);
			HC595_SRCK_H;
		}
		ptr0++;
		ptr1++;
		ptr2++;
		ptr3++;
	}
	LS138_E_H;
	HC595_RCK_L;
	HC595_RCK_H;
	switch(display_cnt)
	{
		case 0: LS138_C_L;LS138_B_L;LS138_A_H;break;
		case 1: LS138_C_L;LS138_B_H;LS138_A_L;break;
		case 2: LS138_C_L;LS138_B_H;LS138_A_H;break;
		case 3: LS138_C_H;LS138_B_L;LS138_A_L;break;
		case 4: LS138_C_H;LS138_B_L;LS138_A_H;break;
		case 5: LS138_C_H;LS138_B_H;LS138_A_L;break;
		case 6: LS138_C_H;LS138_B_H;LS138_A_H;break;
		case 7: LS138_C_L;LS138_B_L;LS138_A_L;break;
		default: display_cnt=0;break;
	}
	LS138_E_L;
	display_cnt++;
	if(display_cnt==8)display_cnt=0;

}

void clearScreen()
{
	memset(display_buffer,0x00,256);
}

void putChar(char c)
{
	
}

int main()
{
	uint8 i,j;
	LED_SCREEN_INI();
	Timer0_Initial();
	
	while(1)
	{
		memset(display_buffer,0x55,256);
		delay(500);
		memset(display_buffer,0xaa,256);
		delay(500);
		memset(display_buffer,0xff,256);
		delay(500);
		clearScreen();
		writeTest();
		//display_buffer[0]=0x01;
		//display_buffer[8]=0x02;
		//display_buffer[16]=0x04;
		//display_buffer[24]=0x08;
		//display_buffer[32]=0x10;
		//display_buffer[40]=0x20;
		//display_buffer[48]=0x40;
		//display_buffer[56]=0x80;
		//writeOneHanzi(0, 0,0);
		delay(1500);
	}
}
